5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 .
"${source_path}/build/make/configure.sh"
23 ${toggle_libs} libraries
24 ${toggle_examples} examples
25 ${toggle_docs} documentation
26 ${toggle_unit_tests} unit tests
27 --libc=PATH path to alternate libc
28 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
29 --sdk-path=PATH path to root of sdk (iOS, android builds only)
30 ${toggle_fast_unaligned} don't use unaligned accesses, even when
31 supported by hardware [auto]
32 ${toggle_codec_srcs} in/exclude codec library source code
33 ${toggle_debug_libs} in/exclude debug version of libraries
34 ${toggle_md5} support for output of checksum data
35 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
36 ${toggle_vp8} VP8 codec support
37 ${toggle_vp9} VP9 codec support
38 ${toggle_internal_stats} output of encoder internal stats for debug, if supported (encoders)
39 ${toggle_mem_tracker} track memory usage
40 ${toggle_postproc} postprocessing
41 ${toggle_multithread} multithreaded encoding and decoding
42 ${toggle_spatial_resampling} spatial sampling (scaling) support
43 ${toggle_realtime_only} enable this option while building for real-time encoding
44 ${toggle_onthefly_bitpacking} enable on-the-fly bitpacking in real-time encoding
45 ${toggle_error_concealment} enable this option to get a decoder which is able to conceal losses
46 ${toggle_runtime_cpu_detect} runtime cpu detection
47 ${toggle_shared} shared library support
48 ${toggle_static} static library support
49 ${toggle_small} favor smaller size over speed
50 ${toggle_postproc_visualizer} macro block / block level visualizers
51 ${toggle_multi_res_encoding} enable multiple-resolution encoding
52 ${toggle_temporal_denoising} enable temporal denoising and disable the spatial denoiser
55 Codecs can be selectively enabled or disabled individually, or by family:
58 --disable-<codec>-encoder
59 --disable-<codec>-decoder
61 Codecs available in this distribution:
63 #restore editor state '
69 for c
in ${CODECS}; do
71 if [ "${family}" != "${last_family}" ]; then
72 [ -z "${str}" ] ||
echo "${str}"
73 str
="$(printf ' %10s:' ${family})"
75 str
="${str} $(printf '%10s' ${c#*_})"
83 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
86 # all_platforms is a list of all supported target platforms. Maintain
87 # alphabetically by architecture, generic-gnu last.
88 all_platforms
="${all_platforms} armv5te-android-gcc"
89 all_platforms
="${all_platforms} armv5te-linux-rvct"
90 all_platforms
="${all_platforms} armv5te-linux-gcc"
91 all_platforms
="${all_platforms} armv5te-none-rvct"
92 all_platforms
="${all_platforms} armv6-darwin-gcc"
93 all_platforms
="${all_platforms} armv6-linux-rvct"
94 all_platforms
="${all_platforms} armv6-linux-gcc"
95 all_platforms
="${all_platforms} armv6-none-rvct"
96 all_platforms
="${all_platforms} armv7-android-gcc" #neon Cortex-A8
97 all_platforms
="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
98 all_platforms
="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
99 all_platforms
="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
100 all_platforms
="${all_platforms} armv7-none-rvct" #neon Cortex-A8
101 all_platforms
="${all_platforms} mips32-linux-gcc"
102 all_platforms
="${all_platforms} ppc32-darwin8-gcc"
103 all_platforms
="${all_platforms} ppc32-darwin9-gcc"
104 all_platforms
="${all_platforms} ppc32-linux-gcc"
105 all_platforms
="${all_platforms} ppc64-darwin8-gcc"
106 all_platforms
="${all_platforms} ppc64-darwin9-gcc"
107 all_platforms
="${all_platforms} ppc64-linux-gcc"
108 all_platforms
="${all_platforms} sparc-solaris-gcc"
109 all_platforms
="${all_platforms} x86-android-gcc"
110 all_platforms
="${all_platforms} x86-darwin8-gcc"
111 all_platforms
="${all_platforms} x86-darwin8-icc"
112 all_platforms
="${all_platforms} x86-darwin9-gcc"
113 all_platforms
="${all_platforms} x86-darwin9-icc"
114 all_platforms
="${all_platforms} x86-darwin10-gcc"
115 all_platforms
="${all_platforms} x86-darwin11-gcc"
116 all_platforms
="${all_platforms} x86-darwin12-gcc"
117 all_platforms
="${all_platforms} x86-linux-gcc"
118 all_platforms
="${all_platforms} x86-linux-icc"
119 all_platforms
="${all_platforms} x86-os2-gcc"
120 all_platforms
="${all_platforms} x86-solaris-gcc"
121 all_platforms
="${all_platforms} x86-win32-gcc"
122 all_platforms
="${all_platforms} x86-win32-vs7"
123 all_platforms
="${all_platforms} x86-win32-vs8"
124 all_platforms
="${all_platforms} x86-win32-vs9"
125 all_platforms
="${all_platforms} x86_64-darwin9-gcc"
126 all_platforms
="${all_platforms} x86_64-darwin10-gcc"
127 all_platforms
="${all_platforms} x86_64-darwin11-gcc"
128 all_platforms
="${all_platforms} x86_64-darwin12-gcc"
129 all_platforms
="${all_platforms} x86_64-linux-gcc"
130 all_platforms
="${all_platforms} x86_64-linux-icc"
131 all_platforms
="${all_platforms} x86_64-solaris-gcc"
132 all_platforms
="${all_platforms} x86_64-win64-gcc"
133 all_platforms
="${all_platforms} x86_64-win64-vs8"
134 all_platforms
="${all_platforms} x86_64-win64-vs9"
135 all_platforms
="${all_platforms} universal-darwin8-gcc"
136 all_platforms
="${all_platforms} universal-darwin9-gcc"
137 all_platforms
="${all_platforms} universal-darwin10-gcc"
138 all_platforms
="${all_platforms} universal-darwin11-gcc"
139 all_platforms
="${all_platforms} universal-darwin12-gcc"
140 all_platforms
="${all_platforms} generic-gnu"
142 # all_targets is a list of all targets that can be configured
143 # note that these should be in dependency order for now.
144 all_targets
="libs examples docs"
146 # all targets available are enabled, by default.
147 for t
in ${all_targets}; do
148 [ -f ${source_path}/${t}.mk ] && enable ${t}
151 # check installed doxygen version
152 doxy_version
=$
(doxygen
--version 2>/dev
/null
)
153 doxy_major
=${doxy_version%%.*}
154 if [ ${doxy_major:-0} -ge 1 ]; then
155 doxy_version
=${doxy_version#*.}
156 doxy_minor
=${doxy_version%%.*}
157 doxy_patch
=${doxy_version##*.}
159 [ $doxy_major -gt 1 ] && enable doxygen
160 [ $doxy_minor -gt 5 ] && enable doxygen
161 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
164 # install everything except the sources, by default. sources will have
165 # to be enabled when doing dist builds, since that's no longer a common
167 enabled doxygen
&& php
-v >/dev
/null
2>&1 && enable install_docs
173 enable fast_unaligned
#allow unaligned accesses, if supported by hw
175 enable spatial_resampling
178 enable temporal_denoising
180 [ -d ${source_path}/..
/include
] && enable alt_tree_layout
182 [ -d ${source_path}/${d} ] && disable alt_tree_layout
;
185 if ! enabled alt_tree_layout
; then
186 # development environment
187 [ -d ${source_path}/vp8
] && CODECS
="${CODECS} vp8_encoder vp8_decoder"
188 [ -d ${source_path}/vp9
] && CODECS
="${CODECS} vp9_encoder vp9_decoder"
190 # customer environment
191 [ -f ${source_path}/..
/include
/vpx
/vp8cx.h
] && CODECS
="${CODECS} vp8_encoder"
192 [ -f ${source_path}/..
/include
/vpx
/vp8dx.h
] && CODECS
="${CODECS} vp8_decoder"
193 [ -f ${source_path}/..
/include
/vpx
/vp9cx.h
] && CODECS
="${CODECS} vp9_encoder"
194 [ -f ${source_path}/..
/include
/vpx
/vp9dx.h
] && CODECS
="${CODECS} vp9_decoder"
195 [ -f ${source_path}/..
/include
/vpx
/vp8cx.h
] || disable vp8_encoder
196 [ -f ${source_path}/..
/include
/vpx
/vp8dx.h
] || disable vp8_decoder
197 [ -f ${source_path}/..
/include
/vpx
/vp9cx.h
] || disable vp9_encoder
198 [ -f ${source_path}/..
/include
/vpx
/vp9dx.h
] || disable vp9_decoder
200 [ -f ${source_path}/..
/lib
/*/*mt.lib
] && soft_enable static_msvcrt
203 CODECS
="$(echo ${CODECS} | tr ' ' '\n')"
204 CODEC_FAMILIES
="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
242 implicit_segmentation
249 implicit_compoundinter_weight
359 --disable-codecs) for c
in ${CODECS}; do disable
$c; done ;;
360 --enable-?
*|
--disable-?
*)
361 eval `echo "$opt" | sed 's/--/action=/;s/-/ option=/;s/-/_/g'`
362 if echo "${EXPERIMENT_LIST}" |
grep "^ *$option\$" >/dev
/null
; then
363 if enabled experimental
; then
366 log_echo
"Ignoring $opt -- not in experimental mode."
369 process_common_cmdline
$opt
372 *) process_common_cmdline
"$opt"
378 post_process_cmdline
() {
381 # If the codec family is disabled, disable all components of that family.
382 # If the codec family is enabled, enable all components of that family.
383 log_echo
"Configuring selected codecs"
384 for c
in ${CODECS}; do
385 disabled
${c%%_*} && disable
${c}
386 enabled
${c%%_*} && enable ${c}
389 # Enable all detected codecs, if they haven't been disabled
390 for c
in ${CODECS}; do soft_enable
$c; done
392 # Enable the codec family if any component of that family is enabled
393 for c
in ${CODECS}; do
394 enabled
$c && enable ${c%_*}
397 # Set the {en,de}coders variable if any algorithm in that class is enabled
398 for c
in ${CODECS}; do
399 enabled
${c} && enable ${c##*_}s
405 enabled child || write_common_config_banner
406 enabled universal || write_common_target_config_h
${BUILD_PFX}vpx_config.h
408 # TODO: add host tools target (obj_int_extract, etc)
410 # For fat binaries, call configure recursively to configure for each
411 # binary architecture to be included.
412 if enabled universal
; then
413 # Call configure (ourselves) for each subarchitecture
414 for arch
in $fat_bin_archs; do
415 BUILD_PFX
=${arch}/ toolchain
=${arch} $self --child $cmdline_args ||
exit $?
419 # The write_common_config (config.mk) logic is deferred until after the
420 # recursive calls to configure complete, becuase we want our universal
421 # targets to be executed last.
422 write_common_config_targets
423 enabled universal
&& echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
425 # Calculate the default distribution name, based on the enabled features
428 for cf
in $CODEC_FAMILIES; do
429 if enabled
${cf}_encoder
&& enabled
${cf}_decoder
; then
430 DIST_DIR
="${DIST_DIR}-${cf}"
431 elif enabled
${cf}_encoder
; then
432 DIST_DIR
="${DIST_DIR}-${cf}cx"
433 elif enabled
${cf}_decoder
; then
434 DIST_DIR
="${DIST_DIR}-${cf}dx"
437 enabled debug_libs
&& DIST_DIR
="${DIST_DIR}-debug"
438 enabled codec_srcs
&& DIST_DIR
="${DIST_DIR}-src"
439 ! enabled postproc
&& DIST_DIR
="${DIST_DIR}-nopost"
440 ! enabled multithread
&& DIST_DIR
="${DIST_DIR}-nomt"
441 ! enabled install_docs
&& DIST_DIR
="${DIST_DIR}-nodocs"
442 DIST_DIR
="${DIST_DIR}-${tgt_isa}-${tgt_os}"
444 win
*) enabled static_msvcrt
&& DIST_DIR
="${DIST_DIR}mt" || DIST_DIR
="${DIST_DIR}md"
445 DIST_DIR
="${DIST_DIR}-${tgt_cc}"
448 if [ -f "${source_path}/build/make/version.sh" ]; then
449 local ver
=`"$source_path/build/make/version.sh" --bare $source_path`
450 DIST_DIR
="${DIST_DIR}-${ver}"
451 VERSION_STRING
=${ver}
453 VERSION_PATCH
=${ver##*.}
455 VERSION_MINOR
=${ver##*.}
457 VERSION_MAJOR
=${ver%.*}
459 enabled child ||
cat <<EOF >> config.mk
462 ifeq (\$(MAKECMDGOALS),dist)
463 DIST_DIR?=${DIST_DIR}
465 DIST_DIR?=\$(DESTDIR)${prefix}
467 LIBSUBDIR=${libdir##${prefix}/}
469 VERSION_STRING=${VERSION_STRING}
471 VERSION_MAJOR=${VERSION_MAJOR}
472 VERSION_MINOR=${VERSION_MINOR}
473 VERSION_PATCH=${VERSION_PATCH}
475 CONFIGURE_ARGS=${CONFIGURE_ARGS}
477 enabled child ||
echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
480 # Write makefiles for all enabled targets
482 for tgt
in libs examples docs solution
; do
483 local tgt_fn
="$tgt-$toolchain.mk"
485 if enabled
$tgt; then
486 echo "Creating makefiles for ${toolchain} ${tgt}"
487 write_common_target_config_mk
$tgt_fn ${BUILD_PFX}vpx_config.h
495 if enabled shared
; then
496 # Can only build shared libs on a subset of platforms. Doing this check
497 # here rather than at option parse time because the target auto-detect
498 # magic happens after the command line has been parsed.
499 if ! enabled linux
; then
501 echo "--enable-shared is only supported on ELF; assuming this is OK"
503 die
"--enable-shared only supported on ELF for now"
507 if [ -z "$CC" ] || enabled external_build
; then
508 echo "Bypassing toolchain for environment detection."
509 enable external_build
511 log fake_check_header
"$@"
514 var
=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
516 # Headers common to all environments
524 [ -f "${d##-I}/$header" ] && result
=true
&& break
529 # Specialize windows and POSIX environments.
532 case $header-$toolchain in
552 check_header stdio.h || die
"Unable to invoke compiler: ${CC} ${CFLAGS}"
553 check_ld
<<EOF || die "Toolchain is unable to link executables"
554 int main(void) {return 0;}
556 # check system headers
557 check_header stdint.h
558 check_header pthread.h
559 check_header sys
/mman.h
560 check_header unistd.h
# for sysconf(3) and friends.
562 check_header vpx
/vpx_integer.h
-I${source_path} && enable vpx_ports
565 process_toolchain
() {
566 process_common_toolchain
568 # Handle universal binaries for this architecture
571 local darwin_ver
=${tgt_os##darwin}
573 # Snow Leopard (10.6/darwin10) dropped support for PPC
574 # Include PPC support for all prior versions
575 if [ $darwin_ver -lt 10 ]; then
576 fat_bin_archs
="$fat_bin_archs ppc32-${tgt_os}-gcc"
579 # Tiger (10.4/darwin8) brought support for x86
580 if [ $darwin_ver -ge 8 ]; then
581 fat_bin_archs
="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
584 # Leopard (10.5/darwin9) brought 64 bit support
585 if [ $darwin_ver -ge 9 ]; then
586 fat_bin_archs
="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
592 # Enable some useful compiler flags
594 enabled werror
&& check_add_cflags
-Werror
595 check_add_cflags
-Wall
596 check_add_cflags
-Wdeclaration-after-statement
597 check_add_cflags
-Wdisabled-optimization
598 check_add_cflags
-Wpointer-arith
599 check_add_cflags
-Wtype-limits
600 check_add_cflags
-Wcast-qual
601 check_add_cflags
-Wvla
602 check_add_cflags
-Wimplicit-function-declaration
603 check_add_cflags
-Wuninitialized
604 check_add_cflags
-Wunused-variable
605 check_add_cflags
-Wunused-but-set-variable
606 enabled extra_warnings || check_add_cflags
-Wno-unused-function
610 enabled werror
&& check_add_cflags
-Werror
611 check_add_cflags
-Wall
612 check_add_cflags
-Wpointer-arith
614 # ICC has a number of floating point optimizations that we disable
615 # in favor of deterministic output WRT to other compilers
616 add_cflags
-fp-model precise
619 # Enable extra, harmless warnings. These might provide additional insight
620 # to what the compiler is doing and why, but in general, but they shouldn't
621 # be treated as fatal, even if we're treating warnings as errors.
623 -Wdisabled-optimization
626 enabled gcc
&& EXTRA_WARNINGS
="${GCC_EXTRA_WARNINGS}"
627 RVCT_EXTRA_WARNINGS
="
630 enabled rvct
&& EXTRA_WARNINGS
="${RVCT_EXTRA_WARNINGS}"
631 if enabled extra_warnings
; then
632 for w
in ${EXTRA_WARNINGS}; do
633 check_add_cflags
${w}
634 enabled gcc
&& enabled werror
&& check_add_cflags
-Wno-error=${w}
638 # ccache only really works on gcc toolchains
639 enabled gcc || soft_disable ccache
640 if enabled mips
; then
641 enable dequant_tokens
645 # Enable the postbuild target if building for visual studio.
649 vs_version
=${tgt_cc##vs}
650 all_targets
="${all_targets} solution"
651 INLINE
="__forceinline"
655 # Other toolchain specific defaults
656 case $toolchain in x86
*|ppc
*|universal
*) soft_enable postproc
;; esac
658 if enabled postproc_visualizer
; then
659 enabled postproc || die
"postproc_visualizer requires postproc to be enabled"
662 # Enable unit tests by default if we have a working C++ compiler.
665 soft_enable unit_tests
668 # GTestLog must be modified to use Android logging utilities.
671 # iOS/ARM builds do not work with gtest. This does not match
675 enabled pthread_h
&& check_cxx
"$@" <<EOF && soft_enable unit_tests
684 ## END APPLICATION SPECIFIC CONFIGURATION
688 print_webm_license
${BUILD_PFX}vpx_config.c
"/*" " */"
689 cat <<EOF >> ${BUILD_PFX}vpx_config.c
690 static const char* const cfg = "$CONFIGURE_ARGS";
691 const char *vpx_codec_build_config(void) {return cfg;}